%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation
%%
%% See the NOTICE file(s) distributed with this work for additional
%% information regarding copyright ownership.
%%
%% This program and the accompanying materials are made available under the terms
%% of the MIT License which is available at https://opensource.org/licenses/MIT
%%
%% SPDX-License-Identifier: MIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Chi language definition for the LaTeX 'listings' package.

\usepackage{listings}
\usepackage{color}
\usepackage{xcolor}
\definecolor{chi-comment-color} {RGB}{128, 128, 128}
\definecolor{chi-keyword-color} {RGB}{  0,   0, 255}
\definecolor{chi-operator-color}{RGB}{  0,  97, 192}
\definecolor{chi-stdlib-color}  {RGB}{128,   0, 255}
\definecolor{chi-string-color}  {RGB}{192,   0,   0}
\lstdefinelanguage{chi} {
  frame=tb,
  captionpos=b,
  numbers=left,
  numbersep=10pt,
  breaklines,
  breakindent=0pt,
  basicstyle=\ttfamily\small,
  showstringspaces=true,
  keywords={
    % Top-level.
    const,
    enum,
    xper,
    func,
    model,
    proc,
    type,
    % Iterative statements.
    for,
    while,
    break,
    continue,
    % Sub-process statements.
    return,
    run,
    start,
    % Other keywords.
    select,
    alt,
    unwind,
    close,
    if,
    elif,
    else,
    delay,
    time,
    end,
    finish,
    pass,
    exit,
    write,
    writeln,
    % Types.
    bool,
    chan,
    dict,
    dist,
    file,
    inst,
    int,
    list,
    matrix,
    real,
    set,
    string,
    timer,
    tuple,
    void,
    % Constants.
    false,
    true,
  },
  keywords=[2]{
    % Operators.
    and,
    div,
    in,
    mod,
    not,
    or,
    sample,
    sub,
  },
  keywords=[3]{
    % 'Simple' conversions.
    abs,
    sign,
    max,
    min,
    ceil,
    floor,
    round,
    % Power and logarithmic functions.
    cbrt,
    sqrt,
    exp,
    ln,
    log,
    % Trigonometry.
    acosh,
    acos,
    asinh,
    asin,
    atanh,
    atan,
    cosh,
    cos,
    sinh,
    sin,
    tanh,
    tan,
    % Distributions.
    bernoulli,
    beta,
    binomial,
    constant,
    lognormal,
    exponential,
    erlang,
    gamma,
    geometric,
    normal,
    poisson,
    random,
    triangle,
    uniform,
    weibull,
    % Container functions.
    dictkeys,
    dictvalues,
    empty,
    size,
    pop,
    enumerate,
    range,
    del,
    insert,
    sort,
    % Other stuff.
    finished,
    ready,
    open,
    channel,
    read,
    eol,
    eof,
    newlines,
  },
  sensitive=true,
  morecomment=[l][\color{chi-comment-color}]{\#},
  morestring=[b][\color{chi-string-color}]",
  keywordstyle=\color{chi-keyword-color},
  keywordstyle=[2]\color{chi-operator-color},
  keywordstyle=[3]\color{chi-stdlib-color},
}
\newcommand{\chifile}[3]
           {\lstinputlisting[language=chi, label={#3}, caption={#2}]{#1}}
\newcommand{\chifrag}[1]
           {\lstinline[language=chi,basicstyle=\ttfamily\normalsize]{#1}}
